% Joe Jupin
% Homework 8
% Segmented pictures

%  clear all variables
clear all;

% set number of clusters
%clusters = 7;
clusters = 4;
% set times to perform k-means
times = 6;

% read images
% names of images
%fpic = {'house.bmp'};
fpic = {'flower2.bmp'};
% transpose gpics
fpic = fpic';
% read images into double matrix
f = double(imread(char(fpic)));
% get gpics dimensions
[ipixs jpixs kpixs] = size(f);

% map image colors into 3-space
[X, R] = imstack2vectors(f);

% get principal component data for 1 to 3 PCs
% set number of principal components to 3
Q3 = 3;
% get 3 principal components
P3 = princomp(X, Q3);
% set number of principal components to 2
Q2 = 2;
% get 2 principal components
P2 = princomp(X, Q2);
% set number of principal components to 1
Q1 = 1;
% get 1 principal component
P1 = princomp(X, Q1);

% reshape the eigen vectors into image
Z = zeros(length(X),3);
Z(:,1:Q3) = P3.Y;
gy = reshape(Z, ipixs, jpixs, kpixs);

% show eigen images
figure;
subplot(2,2,1);
imshow(uint8(gy));
title('Eigen Image');
subplot(2,2,2);
imshow(uint8(gy(:,:,1)));
title('First PC');
subplot(2,2,3);
imshow(uint8(gy(:,:,2)));
title('Second PC');
subplot(2,2,4);
imshow(uint8(gy(:,:,3)));
title('Third PC');

% print original and rgb layaers of original image
figure;
subplot(4,3,1);
imshow(uint8(f));
title('Original Image');
mo = mean(X);
for i=1:3
    Z = zeros(ipixs, jpixs, kpixs);
    Z(:,:,i) = f(:,:,i);
    subplot(4,3,(1+(3*i)));
    imshow(uint8(Z));
    title(sprintf('mean = %f', mo(i)));
end

% reshape the reconstructed 2 PC vectors into image
f2 = reshape(P2.X, ipixs, jpixs, kpixs);

%figure;
% print pca and rgb layaers of pca image
subplot(4,3,2);
imshow(uint8(f2));
title('PCA Image - 2PCs');
mp2 = mean(P2.X);
for i=1:3
    Z = zeros(ipixs, jpixs, kpixs);
    Z(:,:,i) = f2(:,:,i);
    subplot(4,3,(2+(3*i)));
    imshow(uint8(Z));
    title(sprintf('mean = %f', mp2(i)));
end

% reshape the reconstructed 1 PC vectors into image
f1 = reshape(P1.X, ipixs, jpixs, kpixs);

%figure;
% print pca and rgb layaers of pca image
subplot(4,3,3);
imshow(uint8(f1));
title('PCA Image - 1PC');
mp1 = mean(P1.X);
for i=1:3
    Z = zeros(ipixs, jpixs, kpixs);
    Z(:,:,i) = f1(:,:,i);
    subplot(4,3,(3+(3*i)));
    imshow(uint8(Z));
    title(sprintf('mean = %f', mp1(i)));
end

% plot original and pca image colorspaces
figure;
subplot(3,1,1);
plot3(X(:,1),X(:,2),X(:,3),'.r');
axis([0 255 0 255 0 255 0 255]);
title('Original image');
subplot(3,1,2);
plot3(P2.X(:,1),P2.X(:,2),P2.X(:,3),'.r');
axis([0 255 0 255 0 255 0 255]);
title('2 PCs image');
subplot(3,1,3);
plot3(P1.X(:,1),P1.X(:,2),P1.X(:,3),'.r');
axis([0 255 0 255 0 255 0 255]);
title('1 PC image');

% perform k-means times times
for n=1:times

    counts = zeros(clusters, 1);
    avgs = zeros(clusters, 3);
    counts1 = zeros(clusters, 1);
    avgs1 = zeros(clusters, 3);
    counts2 = zeros(clusters, 1);
    avgs2 = zeros(clusters, 3);
    
    % use k-means clustering on 3-space image
    % to find 7 clusters using euclidean distance
    % displaying the state at each iteration
    [idx C sumd] = kmeans(X, clusters, 'display', 'iter');
    [idx1 C1 sumd1] = kmeans(P1.X, clusters, 'display', 'iter');
    [idx2 C2 sumd2] = kmeans(P2.X, clusters, 'display', 'iter');

    % count members of each cluster
    for i=1:length(idx)
        counts(idx(i)) = counts(idx(i)) + 1;
        counts1(idx1(i)) = counts1(idx1(i)) + 1;
        counts2(idx2(i)) = counts2(idx2(i)) + 1;
    end

    % get cluster averages
    for i=1:length(idx)
        for j=1:3
            avgs(idx(i),j) = avgs(idx(i),j) + (X(i,j)/counts(idx(i)));
            avgs1(idx1(i),j) = avgs1(idx1(i),j) + (P1.X(i,j)/counts1(idx1(i)));
            avgs2(idx2(i),j) = avgs2(idx2(i),j) + (P2.X(i,j)/counts2(idx2(i)));
        end
    end

    % declare new image variables
    Y = zeros(length(idx),3);
    Y1 = zeros(length(idx1),3);
    Y2 = zeros(length(idx2),3);

    % replace colors with averages
    for i=1:length(idx)
        for j=1:3
            Y(i,j) = avgs(idx(i),j);
            Y1(i,j) = avgs1(idx1(i),j);
            Y2(i,j) = avgs2(idx2(i),j);
        end
    end

    % reshape processed images
    g = reshape(Y, ipixs, jpixs, kpixs);
    g1 = reshape(Y1, ipixs, jpixs, kpixs);
    g2 = reshape(Y2, ipixs, jpixs, kpixs);

    % print processed images
    if (rem(n,6) == 1)
        figure;
        m = 1;
    end
    subplot(6,3,(m+(2*(m-1))));
    imshow(uint8(g));
    title(sprintf('Orig = %d', sum(sumd)));
    subplot(6,3,(m+(2*(m-1)+1)));
    imshow(uint8(g2));
    title(sprintf('2 PCs = %d', sum(sumd2)));
    subplot(6,3,(m+(2*(m-1)+2)));
    imshow(uint8(g1));
    title(sprintf('1 PC = %d', sum(sumd1)));
    m = m+1;
end